'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _vue = require('vue');

var _vue2 = _interopRequireDefault(_vue);

function _interopRequireDefault(obj) {
  return obj && obj.__esModule ? obj : { default: obj };
}

var props = {
  to: {
    type: String,
    required: true
  }
};

/* eslint-disable no-underscore-dangle */
/* istanbul ignore else */ // can't reimport middleware
if (Array.isArray(_vue2.default._installedPlugins) && _vue2.default._installedPlugins.some(function (_ref) {
  var name = _ref.name;
  return name === 'VueRouter';
}) > -1) {
  (0, _assign2.default)(props, (0, _extends3.default)({
    useVueRouter: {
      type: Boolean,
      default: true
    }
  }, _vue2.default.options.components['router-link'].options.props));
} else {
  _vue2.default.util.warn('Must call Vue.use(VueRouter) before importing scouter-link to include Vue Router functionality.');
}
/* eslint-enable no-underscore-dangle */

exports.default = {
  name: 'vue-scouter-link',
  props: props,
  computed: {
    computedProps: function computedProps() {
      return this.useVueRouter ? (0, _extends3.default)({
        is: 'router-link'
      }, this.$options.propsData) : (0, _extends3.default)({
        is: 'a',
        href: this.to
      }, this.$options.propsData);
    },
    atTargetRoute: function atTargetRoute() {
      if (!this.$el) {
        _vue2.default.util.warn('Cannot compare target route of Scouter Link before component has mounted.');
        return null;
      }
      return this.$el.origin === window.location.origin && this.$el.pathname === window.location.pathname;
    },
    targetEl: function targetEl() {
      if (!this.$el) {
        _vue2.default.util.warn('Cannot get target element of Scouter Link before component has mounted.');
        return null;
      }
      return this.atTargetRoute ? this.$el.hash.replace(/\?.*$/, '') : null;
    }
  },
  methods: {
    scrollToIfFound: function scrollToIfFound(event, options) {
      if (this.targetEl && document.querySelector(this.targetEl)) {
        /* istanbul ignore if */ // can't reimport middleware
        if (!this.$scrollTo) {
          _vue2.default.util.warn('Must call Vue.use(VueScrollto) before importing scouter-link to include Vue Scrollto functionality.');
        } else {
          event.preventDefault();
          this.$scrollTo(this.targetEl, undefined, { options: options });
        }
      }
    }
  }
};
if (module.exports.__esModule) module.exports = module.exports.default;(typeof module.exports === "function" ? module.exports.options : module.exports).template = "\n<component class=\"vue-scouter-link\" v-bind=\"computedProps\" @click.native=\"scrollToIfFound\"></component>\n";
if (module.hot) {
  (function () {
    module.hot.accept();
    var hotAPI = require("vue-hot-reload-api");
    hotAPI.install(require("vue"), true);
    if (!hotAPI.compatible) return;
    if (!module.hot.data) {
      hotAPI.createRecord("_v-30183ea0", module.exports);
    } else {
      hotAPI.update("_v-30183ea0", module.exports, (typeof module.exports === "function" ? module.exports.options : module.exports).template);
    }
  })();
}